# coding: utf-8

"""
    Identity Security Cloud Beta API

    Use these APIs to interact with the Identity Security Cloud platform to achieve repeatable, automated processes with greater scalability. These APIs are in beta and are subject to change. We encourage you to join the SailPoint Developer Community forum at https://developer.sailpoint.com/discuss to connect with other developers using our APIs.

    The version of the OpenAPI document: 3.1.0-beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from sailpoint.beta.models.config_object import ConfigObject
from sailpoint.beta.models.export_options import ExportOptions
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class SpConfigExportResults(BaseModel):
    """
    Response model for config export download response.
    """ # noqa: E501
    version: Optional[StrictInt] = Field(default=None, description="Current version of the export results object.")
    timestamp: Optional[datetime] = Field(default=None, description="Time the export was completed.")
    tenant: Optional[StrictStr] = Field(default=None, description="Name of the tenant where this export originated.")
    description: Optional[StrictStr] = Field(default=None, description="Optional user defined description/name for export job.")
    options: Optional[ExportOptions] = None
    objects: Optional[List[ConfigObject]] = None
    __properties: ClassVar[List[str]] = ["version", "timestamp", "tenant", "description", "options", "objects"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SpConfigExportResults from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of options
        if self.options:
            _dict['options'] = self.options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in objects (list)
        _items = []
        if self.objects:
            for _item in self.objects:
                if _item:
                    _items.append(_item.to_dict())
            _dict['objects'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of SpConfigExportResults from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "version": obj.get("version"),
            "timestamp": obj.get("timestamp"),
            "tenant": obj.get("tenant"),
            "description": obj.get("description"),
            "options": ExportOptions.from_dict(obj.get("options")) if obj.get("options") is not None else None,
            "objects": [ConfigObject.from_dict(_item) for _item in obj.get("objects")] if obj.get("objects") is not None else None
        })
        return _obj


